gitlab-ci: Ensure that version number has three components
[ghc.git] / .gitlab / push-test-metrics.sh
1 #!/usr/bin/env bash
2 # vim: sw=2 et
3 set -euo pipefail
4
5 NOTES_ORIGIN="git@gitlab.haskell.org:ghc/ghc-performance-notes.git"
6 REF="perf"
7
8 fail() {
9 echo "ERROR: $*" >&2
10 exit 1
11 }
12
13 # Check that private key is available (Set on all GitLab protected branches).
14 if [ -z ${PERF_NOTE_KEY+"$PERF_NOTE_KEY"} ]
15 then
16 echo "Not pushing performance git notes: PERF_NOTE_KEY is not set."
17 exit 0
18 fi
19
20 # TEST_ENV must be set.
21 if [ -z ${TEST_ENV+"$TEST_ENV"} ]
22 then
23 fail "Not pushing performance git notes: TEST_ENV must be set."
24 fi
25
26 # Assert that the METRICS_FILE exists and can be read.
27 if [ -z ${METRICS_FILE+"$METRICS_FILE"} ]
28 then
29 fail "\$METRICS_FILE not set."
30 fi
31 if ! [ -r $METRICS_FILE ]
32 then
33 fail "Metrics file not found: $METRICS_FILE"
34 fi
35
36 # Add gitlab as a known host.
37 mkdir -p ~/.ssh
38 echo "|1|+AUrMGS1elvPeLNt+NHGa5+c6pU=|4XvfRsQftO1OgZD4c0JJ7oNaii8= ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAACAQDXilA5l4kOZPx0nM6xDATF+t4fS6te0eYPDwBI/jLWD9cJVtCnsrwMl5ar+/NfmcD0jnCYztUiVHuXyTaWPJYSQpwltfpTeqpo9/z/0MxkPtSl1uMP2cLbDiqA01OWveChktOXwU6hRQ+7MmO+dNRS/iXrRmYrGv/p1W811QgLBLS9fefEdF25n+0dP71L7Ov7riOawlDmd0C11FraE/R8HX6gs6lbXta1kisdxGyKojYSiCtobUaJxRoatMfUP0a9rwTAyl8tf56LgB+igjMky879VAbL7eQ/AmfHYPrSGJ/YlWP6Jj23Dnos5nOVlWL/rVTs9Y/NakLpPwMs75KTC0Pd74hdf2e3folDdAi2kLrQgO2SI6so7rOYZ+mFkCM751QdDVy4DzjmDvSgSIVf9SV7RQf7e7unE7pSZ/ILupZqz9KhR1MOwVO+ePa5qJMNSdC204PIsRWkIO5KP0QLl507NI9Ri84+aODoHD7gDIWNhU08J2P8/E6r0wcC8uWaxh+HaOjI9BkHjqRYsrgfn54BAuO9kw1cDvyi3c8n7VFlNtvQP15lANwim3gr9upV+r95KEPJCgZMYWJBDPIVtp4GdYxCfXxWj5oMXbA5pf0tNixwNJjAsY7I6RN2htHbuySH36JybOZk+gCj6mQkxpCT/tKaUn14hBJWLq7Q+Q==" >> ~/.ssh/known_hosts
39 echo "|1|JZkdAPJmpX6SzGeqhmQLfMWLGQA=|4vTELroOlbFxbCr0WX+PK9EcpD0= ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIJknufU+I6A5Nm58lmse4/o11Ai2UzYbYe7782J1+kRk" >> ~/.ssh/known_hosts
40
41 # Setup ssh keys.
42 eval `ssh-agent`
43 echo "ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAABAQDJPR1vrZgeGTXmgJw2PsJfMjf22LcDnVVwt3l0rwTZ+8Q2J0bHaYxMRKBco1sON6LGcZepw0Hy76RQ87v057pTz18SXvnfE7U/B6v9qBk0ILJz+4BOX9sEhxu2XmScp/wMxkG9IoyruMlsxXzd1sz09o+rzzx24U2Rp27PRm08vG0oipve6BWLbYEqYrE4/nCufqOJmGd56fju7OTU0lTpEkGDEDWGMxutaX2CbTbDju7qy07Ld8BjSc9aHfvuQaslUbj3ex3EF8EXahURzGpHQn/UFFzVGMokFumiJCAagHQb7cj6jOkKseZLaysbA/mTBQsOzjWiRmkN23bQf1wF ben+ghc-ci@smart-cactus.org" > ~/.ssh/perf_rsa.pub
44 touch ~/.ssh/perf_rsa
45 chmod 0600 ~/.ssh/perf_rsa
46 echo "$PERF_NOTE_KEY" >> ~/.ssh/perf_rsa
47 ssh-add ~/.ssh/perf_rsa
48
49 # Reset the git notes and append the metrics file to the notes, then push and return the result.
50 # This is favoured over a git notes merge as it avoids potential data loss/duplication from the merge strategy.
51 function reset_append_note_push {
52 git fetch -f $NOTES_ORIGIN refs/notes/$REF:refs/notes/$REF || true
53 echo "git notes --ref=$REF append -F $METRICS_FILE HEAD"
54 git notes --ref=$REF append -F $METRICS_FILE HEAD
55 echo "git push $NOTES_ORIGIN refs/notes/$REF"
56 git push $NOTES_ORIGIN refs/notes/$REF
57 }
58
59 # Push the metrics file as a git note. This may fail if another task pushes a note first. In that case
60 # the latest note is fetched and appended.
61 MAX_RETRY=20
62 until reset_append_note_push || [ $MAX_RETRY -le 0 ]
63 do
64 ((MAX_RETRY--))
65 echo ""
66 echo "Failed to push git notes. Fetching, appending, and retrying... $MAX_RETRY retries left."
67 done